routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/{lang}', 'LocaleController@index');

Route::get('/', function () {
    return view('home');
})->middleware('auth');


Route::group(['middleware' => 'auth', 'prefix' => 'admin'], function () {
    Route::resource('companies', 'CompanyController');
    Route::resource('employees', 'EmployeeController');
});




Route::get('mailable', function () {

    return new App\Mail\NewCompanyNotification;
});

app/Company.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    protected $fillable = ['name', 'email', 'logo', 'website'];
}

app/Http/Controllers/CompanyController.php
<?php

namespace App\Http\Controllers;

use App\Company;
use Illuminate\Http\Request;
use App\Mail\NewCompanyNotification;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\DB;

class CompanyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $pageTitle = 'List of Companies';
        return view('admin.companies.index', ['companies' => Company::paginate(10), 'pageTitle' => $pageTitle]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $pageTitle = 'Create Company';
        return view('admin.companies.form', ['pageTitle' => $pageTitle]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validatedData = $request->validate([
            'name' => 'required',
            'logo' => 'dimensions:min_width=100,min_height=100',
        ]);

        DB::transaction(function () use ($request){
            $request->file('logo') ? $request->file('logo')->store('public') : '';

            $company = new Company([
                "name" => $request->get('name'),
                "website" => $request->get('website'),
                "email" => $request->get('email'),
                "logo" => $request->file('logo') ? $request->file('logo')->hashName() : ''
            ]);
            $company->save(); 

            $email = $request->get('email');
            Mail::to($email)->send(new NewCompanyNotification);
        });
        return redirect(route('companies.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function show(Company $company)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $company = Company::find($id);
        $pageTitle = 'Edit Company';

        return view('admin.companies.form', ['company' => $company, 'pageTitle' => $pageTitle]);

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $validatedData = $request->validate([
            'name' => 'required',
            'logo' => 'dimensions:min_width=100,min_height=100',
        ]);

        DB::transaction(function () use ($request, $id){
             $company = Company::find($id);

            $request->file('logo') ? $request->file('logo')->store('public') : '';

            $company->name = $request->get('name');
            $company->website = $request->get('website');
            $company->email = $request->get('email');
            if ($company->logo) {
                $logoInput = $company->logo;
            } else {
                $logoInput = '';
            }
            $company->logo = $request->file('logo') ? $request->file('logo')->hashName() : $logoInput;
            $company->save();
        });

        return redirect(route('companies.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::transaction(function () use ($id) {
            Company::find($id)->delete($id);
        });
    }

}

resources/views/admin/companies/form.blade.php
@extends('adminlte::page')

@section('title', isset($company) ? __('company.title_edit') : __('company.title_create'))

@section('content_header')
    <h1>{{isset($company) ? __('company.title_edit') : __('company.title_create')}}</h1>
@stop

@section('content')
@if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
                <li> @lang($error)</li>
            @endforeach
        </ul>
    </div>
@endif
<form method="post" action="{{isset($company) ? route('companies.update', ['id'=>$company->id]) : route('companies.store')}}" enctype="multipart/form-data">
@csrf
@if(isset($company))
@method('PATCH')
@endif
<div class="form-group">
    <label for="nameInput">Name <span class="text-danger">*</span></label>
    <input type="text" class="form-control" id="nameInput" placeholder="Name" name="name" value="{{$company->name ?? ''}}">
  </div>
  <div class="form-group">
    <label for="emailInput">Email</label>
    <input type="email" class="form-control" id="emailInput" name="email" placeholder="Email " value="{{$company->email ?? ''}}">
  </div>
  <div class="form-group">
    <label for="websiteInput">Website</label>
    <input type="text" class="form-control" id="websiteInput" name="website" placeholder="Website" value="{{$company->website ?? ''}}"> 
  </div>
  <div class="form-group">
    <label for="logoInput">Upload Logo (minimum 100x100)</label>
  
    <input name="logo" type="file" class="form-control-file" id="logoInput">
    @if(isset($company))
        @if($company->logo)
          <img class="img-thumbnail" src="/storage/{{$company->logo}}">
        @endif
    @endif
  </div>
  <button type="submit" class="btn btn-primary">@lang('company.submit')</button>

</form>
@stop

resources/views/admin/companies/index.blade.php
@extends('adminlte::page')

@section('title', __('company.title'))

@section('content_header')
    <h1>@lang('company.title_index')</h1>
@stop

@section('content')
<a class="btn btn-primary" href="{{ route('companies.create') }}">@lang('company.title_create')</a>
    <table id="myTable"  class="stripe">
        <thead>
    <tr>
            <td>Name</td>
            <td>Email</td>
            <td>Website</td>
            <td>Logo</td>
            <td>Action</td>
    </tr>
    </thead>
    <tbody>
    @foreach($companies as $company)
        <tr>
            <td>{{$company->name}}</td>
            <td>{{$company->email}}</td>
            <td>{{$company->website}}</td>
            <td> @if($company->logo)<img src="/storage/{{$company->logo}}" style="height: 100px;">@endif</td>
            <td><a class="btn btn-success" href="{{ route('companies.edit', ['id'=>$company->id]) }}">@lang('company.edit')</a> 
            <button class="btn btn-danger deleteBtn" data-id="{{$company->id}}">@lang('company.delete')</button></td>
        </tr>
    @endforeach
    </tbody>
    </table>
   

    {{ $companies->links() }}
@stop

@section('js')
<script>
$(document).ready( function () {
    $('#myTable').DataTable({
        "bPaginate": false,
        "bLengthChange": false,
        "searching": false, 
        "columnDefs": [
        {"className": "dt-center", "targets": "_all"}
      ],
    });

    $('.deleteBtn').click(function(){
        Swal.fire({
            title: "{{__('validation.confirmation')}}",
            text: "{{__('validation.confirmation_sub')}}",
            type: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: "{{__('validation.delete_btn')}}",
            cancelButtonText: "{{__('validation.cancel_btn')}}"
            }).then((result) => {
            if (result.value) {
                var id = $(this).data("id");
                $.ajax(
                {
                    url: "companies/"+id,
                    type: 'DELETE',
                    data: {
                        "id": id,
                        "_token": "{{ csrf_token() }}",
                    },
                    success: function (){
                        Swal.fire(
                        "{{__('validation.deleted')}}",
                        "{{__('validation.deleted_sub')}}",
                        'success'
                        ).then(function(){
                            window.location = '/admin/companies';
                        })
                    }
                });
           
            }
        })
    })

} );
</script>
@stop